!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
!=begin
!= Module dc_message
!
!   * Editor: Morikawa Yasuhiro, Odaka Masatsugu.
!   * Last Update: 2004/12/25
!   * Created: 2004/12/23
!
!== Overview
!
!G[܂߂bZ[WEx̏o͂sȂB
!((<dcl  MSGDMP.f|URL:http://www.gfd-dennou.org/arch/dcl/dcl-f77doc/rc1/math1/node26.html>))
!̏ʌ݊ƂĂpł悤ɂĂ ()B
!G[̂ dc_error W[ɈˑB
!o͑u͕Wo͂ɌߑłB
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!
!=end

module dc_message

  !=begin
  !== Public Interface
  private
  public:: MessageNotify ! subroutines
  !
  !=end

  !=begin
  !== Generic Procedure
  interface MessageNotify
     module procedure MessageNotifyC
     module procedure MessageNotifyI
  end interface
  !
  !=end

contains
  !=begin
  !== Procedure Interface
  !=end

  !=begin
  !=== bZ[WExEG[̏o
  !
  !bZ[WExEG[o͂ꍇɗp܂B
  !Wo͂ɏo͂܂B
  !
  !^ϐ where ɂ̓vO (Tu[`) ȂǁA
  !vÔǂŃbZ[Wo͂̂̂^܂B
  !
  !^ϐ message ɂ́Ao͂^܂B
  !IvVϐ i, r, d, L, s, n, c1, c2, c3 t鎖o܂B
  !ڍׂɊւĂ dc_string W[ CPrintf QƂĉB
  !
  !^ϐ level ͏o͂郁bZ[W̎ނ߂ŁA
  !((*'W'*)) (܂((*'Warning'*))
  !Ȃ ((*'W'*)) Ŏn܂镶) ^鎖((*x*))A
  !((*'E'*)) (܂((*'Error'*))
  !Ȃ ((*'E'*)) Ŏn܂镶) ^鎖
  !((*G[ (bZ[Wo͌vOI) *))A
  !ȊO̕^鎖((*ʏ̃bZ[W*))o͂܂B
  !ȂAG[o͂ꍇAG[R[h
  ! USR_ECHAR ƂȂ܂B
  !
  subroutine MessageNotifyC(level, where, message, &
       & i, r, d, L, n, c1, c2, c3)
  !
  !==== Dependency
  !
    use dc_types  ,only: string
    use dc_string ,only: UChar, StrHead, Printf, CPrintf
    use dc_error  ,only: StoreError, USR_ECHAR
  !
  !=end
    implicit none

    !=begin
    !==== Input
    !
    character(*), intent(in)          :: level
    character(*), intent(in)          :: where
    character(*), intent(in)          :: message
    integer     , intent(in), optional:: i(:), n(:)
    real        , intent(in), optional:: r(:)
    real(8)     , intent(in), optional:: d(:)
    logical     , intent(in), optional:: L(:)
    character(*), intent(in), optional:: c1, c2, c3
    !=end

    character(string)        :: msg
  continue

    if (   StrHead(  'ERROR', trim( UChar(level) )  )   ) then
       msg = Cprintf(message, &
            & i=i, r=r, d=d, L=L, n=n, c1=c1, c2=c2, c3=c3)
       call StoreError(USR_ECHAR, where, cause_c=msg)

    elseif (   StrHead(  'WARNING', trim( UChar(level) )  )   ) then
       msg = Cprintf(message, &
            & i=i, r=r, d=d, L=L, n=n, c1=c1, c2=c2, c3=c3)
       msg=' *** WARNING [' // trim(where) // '] ***  '// trim(msg)
       call Printf(fmt='%c', c1=msg)

    else
       msg = Cprintf(message, &
            & i=i, r=r, d=d, L=L, n=n, c1=c1, c2=c2, c3=c3)
       msg=' *** MESSAGE [' // trim(where) // '] ***  ' // trim(msg)
       call Printf(fmt='%c', c1=msg)

    endif

    return
  end subroutine MessageNotifyC

  !=begin
  !=== bZ[WExEG[̏o
  !
  !I MessageNotifyC ƓlłA͑Pɐl^ϐ
  !number Ƃ܂B number ͂̂܂ StoreError Ɉn܂B
  !
  subroutine MessageNotifyI(number, where, message, &
       & i, r, d, L, n, c1, c2, c3)
  !
  !==== Dependency
  !
    use dc_string ,only: CPrintf
    use dc_error  ,only: StoreError, USR_ECHAR
  !
  !=end
    implicit none

    !=begin
    !==== Input
    !
    integer,      intent(in)          :: number
    character(*), intent(in)          :: where
    character(*), intent(in), optional:: message
    integer     , intent(in), optional:: i(:), n(:)
    real        , intent(in), optional:: r(:)
    real(8)     , intent(in), optional:: d(:)
    logical     , intent(in), optional:: L(:)
    character(*), intent(in), optional:: c1, c2, c3
    !=end
  continue

    if (.not. present(message)) then
       call StoreError(number, where)

    else
       call StoreError(number, where,  &
            & cause_c=CPrintf( message, &
            & i=i, r=r, d=d, L=L, n=n, c1=c1, c2=c2, c3=c3 )  )
    endif

    return
  end subroutine MessageNotifyI

  !=begin
  !== Output Form
  !  @
  !  *** MESSAGE [where] ***  message
  !  @
  !  *** WARNING [where] ***  message
  !  @
  !  *** ERROR (Code number) [where] *** message
  !
  !=end


end module dc_message
